var Movies = new Array();
var TrailerAddresses = new Array();
var MovieSize = 50;
var BaseURL = "http://movies.yahoo.com";
var scroller = null;
var Range  = 50;
var waitTimer = null;
var waitCount = 0;
var ZipCode  = null;
var SourceSite = "IMDB";

function init() {
    // start wait timer
    for ( var i = 0; i < 12; i++ ) {
        (new Image()).src = "Images/Wait" + i + ".png";
    }

    // read preferences
    if ( window.widget ) {
        ZipCode = widget.preferenceForKey( "ZipCode" );
        var zip = document.getElementById( "zipcode" );
        if ( zip ) zip.value = ZipCode;
        var source = widget.preferenceForKey( "SourceSite" );
        if ( source ) {
            SourceSite = source;
        }
        var select = document.getElementById( "source" );
        for ( var i = 0; i < select.childNodes.length; i++ ) {
            var option = select.childNodes.item( i );
            if ( option.nodeType == 1 && option.tagName.toLowerCase() == "option" ) {
                if ( option.value == SourceSite ) {
                    option.setAttribute( "selected", "true" );
                } else {
                    option.removeAttribute( "selected" );
                }
            }
        }
    }

    // resizable
    var bottom = document.getElementById( "front-bottom" );
    if ( bottom ) {
        bottom.addEventListener( "mousedown", _startResizing, true );
    }

    // scroller
    scroller = new Scroller( document.getElementById( "tableContainer" ),
                             document.getElementById( "rankTable" ),
                             document.getElementById( "track" ),
                             document.getElementById( "thumb" ) );

    window.addEventListener( "mousewheel", receiveMouseWheel, true );

    // create button
    createGenericButton( document.getElementById( "done" ), "Done", flipToFront );


    // load data
    loadFromSelectedSource();        // chart
    setTimeout( findTrailers, 100 ); // traielrs
}

function loadFromSelectedSource() {
    setTimeout( _startWaitTimer, 0 );

    var elem = document.getElementById( "reload" );
    if ( elem ) {
        elem.src = "Images/StopButton1.png";
    }

    if ( SourceSite == "IMDB" ) {
        var loader = new SiteLoader( "http://www.imdb.com/chart/", parseIMDB, loadErrorHandler );
        loader.start();
    } else if ( SourceSite == "Yahoo" ) {
        var loader = new SiteLoader( BaseURL + "/mv/boxoffice/", parseHTML, loadErrorHandler );
        loader.start();
    } else {
        if ( elem ) {
            elem.src = "Images/ReloadButton1.png";
        }
    }
}

function findTrailers() {
    // http://www.apple.com/trailers/
    var loader_trailers = new SiteLoader( "http://www.apple.com/trailers/", _parseAppleTrailers, loadErrorHandler );
    loader_trailers.start();
}

function _parseAppleTrailers( text ) {
    //debug( text );
    var re_trailer = new RegExp( "<a href=\"(/trailers/[^\"]+)\">\\s*([^<]+[^\\s])\\s*</a>", "g" );
    var m = re_trailer.exec( text );
    var trailers = new Array();
    while ( m ) {
        trailers[ _resolveEntity( m[ 2 ] ) ] = "http://www.apple.com" + m[ 1 ];
        debug( m[ 2 ] + " : " + m[ 1 ] );
        m = re_trailer.exec( text );
    }
    TrailerAddresses = trailers;
    for ( var i = 0; i < Movies.length; i++ ) {
        var address = TrailerAddresses[ Movies[ i ].title ];
        if ( address ) {
            Movies[ i ].trailerURL = address;
            Movies[ i ].refresh();
        }
    }
}

function loadErrorHandler( message ) {
    debug( message );
    _loadingEndHandler();
}

function _loadingEndHandler() {
    if ( SiteLoader.prototype.existsRunningProcess() == false ) {
        _stopWaitTimer();
    }
    var reload = document.getElementById( "reload" );
    if ( reload ) {
        if ( SiteLoader.prototype.existsRunningProcess() == false ) {
            reload.src = "Images/ReloadButton1.png";
        } else {
            reload.src = "Images/StopButton1.png";
        }
    }
}

function receiveMouseWheel( event ) {
    var offset = parseInt( event.wheelDelta * -.4 );
    if ( scroller.visible ) {
        var pos_next = offset + scroller.getPosition();
        var limit = scroller.targetBounds.height - scroller.containerBounds.height;
        if ( pos_next < 0 ) pos_next = 0;
        if ( pos_next >= limit ) pos_next = limit;
        scroller.changeView( pos_next );
        scroller.refresh();
    }
}

function flipToFront( event ) {
    var front = document.getElementById( "front" );
    var back  = document.getElementById( "back" );

    // zip code
    var zip = document.getElementById( "zipcode" ).value;
    if ( zip != null && zip.length > 0 ) {
        ZipCode = zip;
        if ( window.widget ) {
            widget.setPreferenceForKey( zip, "ZipCode" );
        }
    } else {
        ZipCode = null;
    }

    // source
    var source = document.getElementById( "source" ).value;
    if ( SourceSite != source ) {
        SourceSite = source;
        setTimeout( loadFromSelectedSource, 100 );
        if ( window.widget ) {
            widget.setPreferenceForKey( SourceSite, "SourceSite" );
        }
    }

    if ( window.widget ) {
        widget.prepareForTransition( "ToFront" );
    }
    back.style.display = "none";
    front.style.display = "block";
    if ( window.widget ) {
        setTimeout( "widget.performTransition();", 0 );
    }
}

function flipToBack( event ) {
    var front = document.getElementById( "front" );
    var back  = document.getElementById( "back" );
    if ( window.widget ) {
        widget.prepareForTransition( "ToBack" );
    }
    back.style.display = "block";
    front.style.display = "none";
    if ( window.widget ) {
        setTimeout( "widget.performTransition();", 0 );
    }
}

// wait timer
function _startWaitTimer() {
    if ( waitTimer ) {
        debug( "already running" );
        return;
    }

    var div = document.getElementById( "wait" );
    if ( div ) {
        div.style.display = "block";
        waitTimer = setInterval( _tickWaitTimer, 66 );
        _tickWaitTimer();
    }
}

function _tickWaitTimer() {
    //debug( "ticking " + waitCount );
    var div = document.getElementById( "wait" );
    if ( div ) {
        div.src = "Images/Wait" + waitCount + ".png";
    } else {
        debug( "no debug" );
    }
    waitCount ++;
    if ( waitCount >= 12 ) waitCount = 0;
}

function _stopWaitTimer() {
    clearInterval( waitTimer );
    waitTimer = null;
    var div = document.getElementById( "wait" );
    div.style.display = "none";
}


/// resizer
var _lastPos = { x:0, y:0 };
var _lastSize = { width:0, height:0 };
var _resizingSize = { width:0, height:0 };
var _resizeRange = { min:130, max:500, bottom:0 };

function _startResizing( event ) {
    //debug( "start resizing" );
    var bottom = document.getElementById( "front-bottom" );
    var front  = document.getElementById( "front" );
    if ( bottom != null && front != null ) {
        window.addEventListener( "mousemove", _processResizing, true );
        window.addEventListener( "mouseup", _stopResizing, true );
        _lastPos.x = event.x;
        _lastPos.y = event.y;
        var bs = document.defaultView.getComputedStyle( front  );
        _lastSize.width = parseInt( bs.getPropertyValue( "width" ) );
        _lastSize.height = parseInt( bs.getPropertyValue( "height" ) );
        _resizingSize.width = _lastSize.width;
        _resizingSize.height = _lastSize.height;
        if ( scroller ) {
            var th = scroller.targetBounds.height;
            var ch = scroller.containerBounds.height;
            var ty = scroller.currentPosition;
            _resizeRange.bottom = th - ty - ch + _lastSize.height;
            _resizeRange.max = _lastSize.height - ch + th;// - ty - ch + _lastSize.height;
        }
    }
}

function _processResizing( event ) {
    var bottom = document.getElementById( "front-bottom" );
    var front  = document.getElementById( "front" );
    var dy = event.y - _lastPos.y;
    var next_height = _lastSize.height + dy;
    if ( next_height < _resizeRange.min ) {
        next_height = _resizeRange.min;
    }
    if ( next_height > _resizeRange.bottom && scroller != null ) {
        var view_height = scroller.containerBounds.height;
        var target_height = scroller.targetBounds.height;
        var pos = target_height - view_height;
        if ( pos < 0 ) {
            next_height = target_height;
            pos = 0;
        } 
        scroller.changeView( pos );
    }
    if ( next_height > _resizeRange.max ) {
        next_height = _resizeRange.max;
    }
    front.style.height = next_height + "px";
    window.resizeBy( 0, next_height - _resizingSize.height );
    _resizingSize.height = next_height;
    //debug( "event.y = " + event.y + ", _lastPos.y = " + _lastPos.y + ", dy = " + dy + ", next = " + next_height );
    if ( scroller ) scroller.refresh();
}
function _stopResizing( event ) {
    window.removeEventListener( "mousemove", _processResizing, true );
    window.removeEventListener( "mouseup", _stopResizing, true );
}


// DOM handling
function _createImage( src, width, height ) {
    var img = document.createElement( "img" );
    if ( src ) {
        img.src = src;
    } else {
        img.src = "";
    }
    img.width = width;
    img.height = height;
    return img;
}

function _createAnchor( text, url ) {
    var anchor = document.createElement( "a" );
    if ( window.widget ) {
        anchor.setAttribute( "onclick", "widget.openURL('" + url + "')" );
    } else {
        anchor.setAttribute( "href", url );
    }
    anchor.appendChild( document.createTextNode( text ) );
    return anchor;
}


function createTable() {
    var table = document.getElementById( "rankTable" );
    if ( Movies == null || Movies.length == 0 ) return;
    while ( table.lastChild ) table.removeChild( table.lastChild );
    for ( var i = 0; i < Movies.length; i+= 2 ) {
        var minfo1 = Movies[ i ];
        var minfo2 = Movies[ i + 1 ];
        var row_odd = document.createElement( "tr" );
        var row_even = document.createElement( "tr" );
        var icon1 = document.createElement( "td" );
        var icon2 = document.createElement( "td" );
        var info1 = document.createElement( "td" );
        var info2 = document.createElement( "td" );
        info1.setAttribute( "class", "oddRow" );
        info2.setAttribute( "class", "evenRow" );
//         icon1.setAttribute( "class", "oddRow" );
//         icon2.setAttribute( "class", "evenRow" );
        row_even.setAttribute( "align", "right" );

        icon1.setAttribute( "valign", "top" );
        icon2.setAttribute( "valign", "bottom" );
        icon1.setAttribute( "class", "leftIcon" );
        icon2.setAttribute( "class", "rightIcon" );
        icon1.setAttribute( "rowspan", "2" );
        icon2.setAttribute( "rowspan", "2" );

        minfo1.iconDivision = icon1;
        minfo2.iconDivision = icon2;

        minfo1.setElements( info1, icon1 );
        minfo2.setElements( info2, icon2 );
        minfo1.write();
        minfo2.write();

        row_odd.appendChild( icon1 );
        row_odd.appendChild( info1 );
        row_odd.appendChild( icon2 );
        row_even.appendChild( info2 );

        table.appendChild( row_odd );
        table.appendChild( row_even );
    }

    if ( scroller ) scroller.refresh();
}

function debug( message ) {
    if ( message == null ) return;
//     if ( window.Logger ) {
//     Logger.log( message.toString() );
//     }
    var div = document.getElementById( "debug" );
    div.appendChild( document.createTextNode( message.toString() ) );
    div.appendChild( document.createElement( "br" ) );
}


function MovieInformation( dataRow ) {
    this.title = null;
    this.rankingTW = null;
    this.rankingLW = null;
    this.distributor = null;
    this.grossTW = null;
    this.grossAC = null;
    this.weeks = null;
    this.theaters = null;
    this.url = null;
    this.link = null;
    this.available = false;
    this.imageSrc = "Images/Cinema.png";
    this.division = null;
    this.iconDivision = null;
    this.reviewURL = null;
    this.trailerURL = null;
    this.mid = null;
    this.zip = null;

    if ( dataRow ) {
        try {
            children = dataRow.childNodes;
            this.rankingTW = getInsideTexts( dataRow, "", "TD" );
            this.rankingLW = getInsideTexts( dataRow, "", "TD,2" );
            this.title = getInsideTexts( dataRow, "", "TD,3" );
            this.url = BaseURL + getElementAt( dataRow, "TD,3/A" ).attributes.item( 0 ).value;
            this.distributor = getInsideTexts( dataRow, "", "TD,4" );
            this.grossTW = getInsideTexts( dataRow, "", "TD,5" );
            this.grossAC = getInsideTexts( dataRow, "", "TD,6" );
            this.weeks =getInsideTexts( dataRow, "", "TD,7" );
            this.theaters = getInsideTexts( dataRow, "", "TD,8" );
            this.available = true;
        } catch ( e ) {
            debug( e );
        }
    }
}


MovieInformation.prototype.toString = function() {
    var output = this.rankingTW + " " + this.rankingLW + " : " + this.title + " / " + this.url;
    return output;
};

MovieInformation.prototype.loadLinks = function() {
    var loader = new SiteLoader( this.url, MovieInformation__parseHTML, loadErrorHandler, this );
    loader.start();
};

MovieInformation.prototype.loadIMDBLink = function() {
    var loader = new SiteLoader( this.url, MovieInformation__parseIMDBHTML, loadErrorHandler, this );
    loader.start();
    //debug( this.url );
};

MovieInformation.prototype.parseIMDB = function( text ) {
    var lines = text.split( "\n" );
    var re_anchor = new RegExp( "<img .*src=\"([^\"]+)\"" );
    for ( var i = 0; i < lines.length; i++ ) {
        if ( lines[ i ].indexOf( "\"poster\"" ) >= 0 ) {
            var m = re_anchor.exec( lines[ i ] );
            if ( m ) {
                this.imageSrc = m[ 1 ];
                this.refresh();
                break;
            }
        }
    }
};

function MovieInformation__parseIMDBHTML( text, owner ) {
    if ( owner ) owner.parseIMDB( text );
}



MovieInformation.prototype.refresh = function() {
    if ( TrailerAddresses[ this.title ] != null ) {
        this.trailerURL = TrailerAddresses[ this.title ];
    }
    this.write();
    _loadingEndHandler();
};

MovieInformation.prototype.setElements = function( div, idiv ) {
    this.division = div;
    this.iconDivision = idiv;
};

MovieInformation.prototype.write = function() {
    if ( this.division == null ) return;
    while ( this.division.lastChild ) {
        this.division.removeChild( this.division.lastChild );
    }
    var e1 = document.createElement( "div" );
    e1.setAttribute( "class", "title" );
    var number = document.createElement( "span" );
    number.setAttribute( "class", "rankNumber" );
    number.appendChild( document.createTextNode( this.rankingTW ) );
    e1.appendChild( number );
    e1.appendChild( _createAnchor( this.title, this.url ) );//document.createTextNode( this.title ) );
    this.division.appendChild( e1 );

    var e2 = document.createElement( "div" );
    e2.setAttribute( "class", "links" );
    if ( this.mid ) {
        var e2a = document.createElement( "a" );
        e2a.mid = this.mid;
        e2a.appendChild( document.createTextNode( "Showtimes" ) );
        e2a.url = this.url;
        e2a.setAttribute( "onclick", "openShowtimeSite(event,this);" );
        e2.appendChild( e2a );
    } else {
        debug( "no ID for " + this.title );
    }

    if ( this.trailerURL != null && this.trailerURL.length > 0 ) {
        e2.appendChild( _createAnchor( "Trailer", this.trailerURL ) );
    }
//     if ( this.reviewURL ) {
//         e2.appendChild( _createAnchor( "Reviews", this.reviewURL ) );
//     }

    var keyword = this.title;//escape( this.title );
    var url_amazon = "http://www.amazon.com/gp/associates/link-types/searchbox.html?tag=wobsofweewidg-20&creative=374001&campaign=211041&mode=blended&keyword=" + keyword + "&Submit.x=14&Submit.y=11&Submit=Go";
    e2.appendChild( _createAnchor( "Products", url_amazon ) );
    //e2.appendChild( document.createTextNode( "Review Products" ) );
    this.division.appendChild( e2 );

    if ( this.iconDivision == null ) return;
    while ( this.iconDivision.lastChild ) {
        this.iconDivision.removeChild( this.iconDivision.lastChild );
    }
    var img = _createImage( this.imageSrc, 45, 60 );
//     if ( this.trailerURL != null && this.trailerURL.length > 0 ) {
//         var link_img = document.createElement( "a" );
//         link_img.setAttribute( "href", this.trailerURL );
//         link_img.appendChild( img );
//         img.setAttribute( "style", "border:2px red solid" );
//         this.iconDivision.appendChild( link_img );

// //         var is = document.defaultView.getComputedStyle( this.iconDivision );
// //         var ileft = parseInt( is.getPropertyValue( "left" ) );
// //         var itop  = parseInt( is.getPropertyValue( "top" ) );
// //         //var istyle = "left:" + ileft + ";top:" + itop 

// //         var img_camera = document.createElement( "img" );
// // //         img.style.position = "absolute";
// // //         img.style.left = ileft + "px";
// // //         img.style.top = itop + "px";
// //         img_camera.setAttribute( "src", "Images/Camera.png" );
// // //         img.setAttribute( "style", "position:absolute;border:1px solid red;left:0px;top:0px;" );
// //         img_camera.setAttribute( "class", "camera" );
// //         img_camera.style.left = ( ileft - 20 ) + "px";
// //         if ( parseInt( this.rankingTW ) % 2 == 0 ) {
// //             img_camera.style.top = ( itop + 30 ) + "px";
// //             //img_camera.setAttribute( "class", "cameraRight" );
// //         } else {
// //             img_camera.style.top = ( itop + 30 ) + "px";
// //             //img_camera.setAttribute( "class", "cameraLeft" );
// //         }
// //          this.iconDivision.appendChild( img_camera );
//     } else {
    this.iconDivision.appendChild( img );
//    }
};

function openShowtimeSite( event, elem ) {
    var mid = elem.mid;
    var url = elem.url;
    //debug( "openShowtimeSite : " + mid + " " + url );
    if ( mid ) {
        //debug( "URL : " + url );
        var url_showtime;

        if ( url.indexOf( "yahoo.com" ) >= 0 ) {
            var date = new Date();
            var dstr = ( date.getYear() + 1900 ) 
                + ( "0" + ( date.getMonth() + 1 ) ).substring( 0, 2 ) 
                + ( "0" + ( date.getDate() ) ).substring( 0, 2 );
            url_showtime = BaseURL + "/showtimes/movie?mid=" + mid + "&date=" + dstr;
            if ( ZipCode ) {
                url_showtime += "&z=" + ZipCode;
            }
        } else if ( url.indexOf( ".imdb.com" ) >= 0 ) { // imdb
            debug( "IMDB " + url );
            url_showtime = url + "cinemashowtimes";//"http://www.imdb.com/title/tt0432348/cinemashowtimes?location=98101;range=50";
            debug( url_showtime );
            if ( ZipCode ) {
                url_showtime += "?location=" + ZipCode + ";range=" + Range;
            debug( url_showtime );
            }
        } else {
            debug( "no showtime address for " + this.title );
            return;
        }
        debug( url_showtime );
        if ( window.widget ) {
            widget.openURL( url_showtime );
        } else {
            window.open( url_showtime );
        }
    }
}



// MovieInformation.prototype.writeInformation = function( td ) {
//     var e1 = document.createElement( "div" );
//     e1.setAttribute( "class", "title" );
//     e1.appendChild( document.createTextNode( this.title ) );
//     td.appendChild( e1 );

//     var e2 = document.createElement( "div" );
//     e2.setAttribute( "class", "links" );
//     e2.appendChild( document.createTextNode( "Review Products" ) );
//     td.appendChild( e2 );
// };

function _resolveEntity( text ) {
    text = text.replace( /&quote;/g, '"' );
    text = text.replace( /&amp;/g, '&' );
    text = text.replace( /&lt;/g, '<' );
    text = text.replace( /&gt;/g, '>' );
    text = text.replace( /&#34;/g, '"' );
    text = text.replace( /&#38;/g, '&' );
    text = text.replace( /&#60;/g, '<' );
    text = text.replace( /&#62;/g, '>' );
    return text;
}

function parseIMDB( html ) {
    if ( html == null ) html = contents;
    var re_title = new RegExp( "<a href=\"(/title/[^\"]+)\">\\s*([^<]*[^\\s])\\s*</a>", "gi" );
    var m = re_title.exec( html );
    var rank = 1;
    var data = new Array();
    while ( m ) {
        debug( m[ 1 ] + " : " + m[ 2 ] );
        var info = new MovieInformation();
        info.title = _resolveEntity( m[ 2 ] );
        info.mid = m[ 1 ].split( "/" )[ 2 ];
        debug( m[ 1 ] + " :: " + info.mid );
        info.rankingTW = rank;
        info.url = "http://www.imdb.com" + m[ 1 ];
        data.push( info );
        rank ++;
        m = re_title.exec( html );
    }
    Movies = data;
    createTable();
    setTimeout( _loadAllIMDBLinks, 50 );
    //debug( html );
}

function _loadAllIMDBLinks() {
    if ( Movies == null ) return;
    for ( var i = 0; i < Movies.length; i++ ) {
        Movies[ i ].loadIMDBLink();
    }
    _loadingEndHandler();
}

function parseHTML( html ) {
    if ( html == null ) html = contents;
    var epos = html.indexOf( "</SELECT>" );
    var p1 = html.indexOf( "<table", epos );
    var p2 = html.indexOf( "</table>", p1 );

    var parser = new _HTMLParser();
    var htmldoc = parser.parse( html.substring( p1, p2 + 8 ) );

    Movies = new Array();
    for ( var count = 2; count < MovieSize + 2; count ++ ) {
        var row = getElementAt( htmldoc.firstChild, "TABLE/TR," + count );
        if ( row == null ) {
            break;
        }

        var info = new MovieInformation( row );
        Movies.push( info );
        //debug( info );
    }

    createTable();
    setTimeout( _loadAllLinks, 50 );
    return Movies;
}

function _loadAllLinks() {
    if ( Movies == null ) return;
    for ( var i = 0; i < Movies.length; i++ ) {
        debug( "loading information from yahoo " + i );
        Movies[ i ].loadLinks();
    }
    _loadingEndHandler();
}

function MovieInformation__parseHTML( text, minfo ) {
    // review
    var re_review = new RegExp( "<a\\s+[^>]+>\\d+\\sreviews?</a>", "img" );
    var re_href = new RegExp( "href=((\"([^\"]+)\")|([^\"'\\s][^\\s]+))", "i" );
    var re_showtime = new RegExp( "<a\\s+[^>]+>[^<]*showtimes &amp; tickes[^<]*</a>", "im" );

    re_showtime = new RegExp( "<a\\s+[^>]+>\\W*?showtimes", "i" );

    // read a review link
    var m_review = re_review.exec( text );
    if ( m_review ) {
        var mref = re_href.exec( m_review[ 0 ] );
        if ( mref ) {
            if ( mref[ 2 ] == null || mref[ 2 ].length == 0 ) {
                minfo.reviewURL = mref[ 4 ];
            } else {
                minfo.reviewURL = mref[ 3 ];
            }
        }
        //debug( minfo.reviewURL + " " + mref );
    } else {
        debug( "no reviews for " + minfo.title );
    }

    // read a showtime link
    var m_showtime = re_showtime.exec( text );
    var re_mid = new RegExp( "mid=(\\d+)" );
    while ( m_showtime ) {
        var mref = re_href.exec( m_showtime[ 0 ] );
        var surl = null;
        if ( mref ) {
            if ( mref[ 2 ] == null || mref[ 2 ].length == 0 ) {
                surl = mref[ 4 ];
            } else {
                surl = mref[ 3 ];
            }
        }
        var m_mid = re_mid.exec( surl );
        if ( m_mid ) {
            minfo.mid = m_mid[ 1 ];
            break;
        }
        m_showtime = re_showtime.exec( text );
    }

    // find image
    var re_img = new RegExp( "<img[^>]+>", "img" );
    var re_width  = new RegExp( "width=\"?(\\d+)\"?", "m" );
    var re_height = new RegExp( "height=\"?(\\d+)\"?", "m" );
    var re_src = new RegExp( "src=((\"([^\"]+)\")|([^\"'\\s][^\\s]+))", "m" );
    var m = re_img.exec( text );
    while ( m ) {
        var mw = re_width.exec( m[ 0 ] );
        var ms = re_src.exec( m[ 0 ] );
        var mh = re_height.exec( m[ 0 ] );
        if ( mw != null && ms != null && mh != null ) {
            var width = parseInt( mw[ 1 ] );
            var height = parseInt( mh[ 1 ] );
            var ratio = width / height;
            if ( height > 100 && ratio > 0.65 && ratio < 0.75 ) {
                var src = ms[ 3 ];
                if ( ms[ 2 ] == null || ms[ 2 ].length == 0 ) {
                    src = ms[ 4 ];
                }
                if ( minfo ) minfo.imageSrc = src;
                //debug( "size = ( " + mw[ 1 ] + ", " + mh[ 1 ] + " )  src = " + src );
                break;
            }
        }
        m = re_img.exec( text );
    }

    // link to trailer
    if ( TrailerAddresses[ minfo.title ] ) {
        minfo.trailerURL = TrailerAddresses[ minfo.title ];
    }

    // refresh
    if ( minfo ) {
        debug( minfo );
        minfo.refresh();
    }
}


// reload actions
function reloadButtonDown() {
    var elem = document.getElementById( "reload" );
    if ( elem == null ) return;
    elem.addEventListener( "mouseup", reloadButtonUp, true );
    elem.addEventListener( "mouseout", reloadButtonOut, true );
    if ( SiteLoader.prototype.existsRunningProcess() ) {
        elem.src = "Images/StopButton2.png";
    } else {
        elem.src = "Images/ReloadButton2.png";
    }
}

function reloadButtonOut() {
    var elem = document.getElementById( "reload" );
    if ( elem == null ) return;
    elem.removeEventListener( "mouseup", reloadButtonUp, true );
    elem.removeEventListener( "mouseout", reloadButtonOut, true );
    if ( SiteLoader.prototype.existsRunningProcess() ) {
        elem.src = "Images/StopButton1.png";
    } else {
        elem.src = "Images/ReloadButton1.png";
    }
}

function reloadButtonUp() {
    var elem = document.getElementById( "reload" );
    if ( elem == null ) return;
    if ( SiteLoader.prototype.existsRunningProcess() ) {
        elem.src = "Images/ReloadButton1.png";
        SiteLoader.prototype.abortAll();
        _stopWaitTimer();
    } else {
        // reload all
        loadFromSelectedSource();
        setTimeout( findTrailers, 100 ); 
    }
}
